<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use App\Http\Helpers\UserHelpers;
use Illuminate\Support\Facades\DB;

class LoadTenant
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        if (session()->has("RESULTAT_USERNAME")) {
            $namebase = DB::table('users')
                ->selectRaw('namebase')
                ->join('geststudent_r', 'users.matricule', '=', 'geststudent_r.matricule')
                ->join('etablissement', 'geststudent_r.idEtablissement', '=', 'etablissement.idEtablissement')
                ->where('username', session('RESULTAT_USERNAME'))
                ->first()->namebase;
            UserHelpers::changeEnv(['database' => $namebase]);
        } else
            return redirect('/');
        return $next($request);
    }
}
